#version 410 core

in vec3 vertex_pos;
in vec3 vertex_nor;
in vec2 vertex_tex;
in float scalar;

uniform mat4 V;

out vec3 color;

//******************************************************************************

void main()
{
    vec3 cylinder_color = vec3(scalar, 0, 1 - scalar);
    
    // rotate the light with the camera
    vec3 light_pos = vec3(transpose(V) * vec4(0, 0, 10, 0));
    vec3 light_dir = normalize(light_pos - vertex_pos);
    vec3 normal_dir = normalize(vertex_nor);
    vec3 diffuse_light = cylinder_color * dot(normal_dir, light_dir);
    vec3 ambient_light = cylinder_color;
    
    color = (diffuse_light + ambient_light) / 2;
}
