#version 410 core

in vec3 vertex_pos;
in vec3 vertex_nor;
in vec2 vertex_tex;

uniform mat4 V;
uniform sampler2D tex;

out vec3 color;

//******************************************************************************

void main()
{
    vec3 map_color = texture(tex, vertex_tex).rgb;
    
    // rotate the light with the camera
    vec3 light_pos = vec3(transpose(V) * vec4(0, 0, 10, 0));
    vec3 light_dir = normalize(light_pos - vertex_pos);
    vec3 normal_dir = normalize(vertex_nor);
    vec3 diffuse_light = map_color * dot(normal_dir, light_dir);
    vec3 ambient_light = map_color;
    
    color = (diffuse_light + ambient_light) / 2;
}
